init python:
    mensaje = ""
    tesoros_colectados = str(0)
    posicion_mago_x = 0.0
    posicion_mago_y = 0.0
    cant_pos_x = round(1.0/20.0, 8)
    cant_pos_y = round(1.0/11.25, 8)
    coor_mago = [15, 3]
    mapa_no = 1
    enemigo = ""
    enemigo_coor = []
    victoria = False
    mapas = {0: {"nombre": "mapa_combate"},
            1: {"nombre": "mapa_1",
                "n": {"tipo": "direccion", "valor": 2, "coor": [6, 10]},
                "a": {"tipo": "tesoro", "valor": 3}},
            2: {"nombre": "mapa_2",
                "s": {"tipo": "direccion", "valor": 1, "coor": [6, 0]},
                "p": {"tipo": "direccion", "valor": 3, "coor": [9, 10]},
                "a": {"tipo": "mensaje", "valor": "¡Un refrescante chapuzón en verano!"}},
            3: {"nombre": "mapa_3",
                "p": {"tipo": "direccion", "valor": 2, "coor": [1, 4]},
                "a": {"tipo": "mensaje", "valor": "Está muy oscuro para ver, necesito luz."}}}

    def coor_a_pos(coor):
        return [round(coor[0] * cant_pos_x, 2), round(coor[1] * cant_pos_y, 2)]

    def leer_mapa(n):
        f = renpy.file(mapas[n]["nombre"] + ".csv")
        af = []
        ac = []
        for l in f:
            af = []
            linea = l.rstrip().split(',')
            for li in linea:
                af.append(li)
            ac.append(af)

        del ac[-1]
        return ac

    def leer_mapa_enemigos(n):
        enemigos = [[None for x in range(20)] for y in range(12)]
        f = renpy.file(mapas[n]["nombre"] + "_enemigos.csv")
        fi = 0
        co = 0

        for l in f:
            linea = l.rstrip().split(',')
            for li in linea:
                if int(li) >= 0:
                    enemigos[fi][co] = li
                co += 1
            co = 0
            fi += 1
        return enemigos
    mapa_datos = leer_mapa(mapa_no)
    mapa_enemigos = leer_mapa_enemigos(mapa_no)
    posicion_mago_x, posicion_mago_y = coor_a_pos(coor_mago)

label start:
    $ quick_menu = False

    window hide None

    call screen mostrar_mapa

screen mostrar_mapa:
    add mapas[mapa_no]["nombre"] + "_a.png":
        pos [0, 0]
    add "mago.png":
        pos [posicion_mago_x, posicion_mago_y]
    $ x = 0
    $ y = 0
    for i in mapa_enemigos:
        for j in i:
            if j != None:
                add j+".png":
                    pos coor_a_pos([y, x])
            $ y += 1
        $ y = 0
        $ x += 1
    add mapas[mapa_no]["nombre"] + "_b.png":
        pos [0, 0]
    frame:
        background Solid((255,255,255, 230))
        pos [0.05, 0.05]
        vpgrid:
            cols 2
            spacing 40
            xsize (3*64)
            text "Tesoro: ":
                bold True
            text tesoros_colectados

            text ""
            text ""

    text mensaje:
        at transform:
            pos [0.5, 0.5] alpha 0.0
            linear 0.5 alpha 1.0

    key "K_RIGHT" action Call("mover", coor_mago, "derecha")
    key "K_LEFT" action Call("mover", coor_mago, "izquierda")
    key "K_UP" action Call("mover", coor_mago, "arriba")
    key "K_DOWN" action Call("mover", coor_mago, "abajo")

label mover(coor=[0, 0], direcc="derecha"):
    python:
        nueva_coor = coor
        mensaje = ""
        #Definir la nueva coordenada
        if direcc == "derecha" and nueva_coor[0] < (len(mapa_datos[0]) - 1):
            nueva_coor[0] += 1

        if direcc == "izquierda" and nueva_coor[0] > 0:
            nueva_coor[0] -= 1

        if direcc == "arriba" and nueva_coor[1] > 0:
            nueva_coor[1] -= 1

        if direcc == "abajo" and nueva_coor[1] < (len(mapa_datos) - 1):
            nueva_coor[1] += 1

        if mapa_enemigos[nueva_coor[1]][nueva_coor[0]] != None:
            enemigo = mapa_enemigos[nueva_coor[1]][nueva_coor[0]]
            enemigo_coor = [nueva_coor[1], nueva_coor[0]]
            renpy.transition(dissolve)
            renpy.call_screen("mapa_combate")

        try:
            int(mapa_datos[nueva_coor[1]][nueva_coor[0]])
        except ValueError:
            #El valor de la coordenada es una letra
            if mapa_datos[nueva_coor[1]][nueva_coor[0]] in mapas[mapa_no]:
                if mapas[mapa_no][mapa_datos[nueva_coor[1]][nueva_coor[0]]]["tipo"] == "direccion":
                    #Moviendose a nuevo mapa
                    nuevo_mapa = mapas[mapa_no][mapa_datos[nueva_coor[1]][nueva_coor[0]]]["valor"]
                    nueva_coor = mapas[mapa_no][mapa_datos[nueva_coor[1]][nueva_coor[0]]]["coor"]
                    mapa_datos = leer_mapa(nuevo_mapa)
                    mapa_no = nuevo_mapa
                    mapa_enemigos = leer_mapa_enemigos(mapa_no)
                elif mapas[mapa_no][mapa_datos[nueva_coor[1]][nueva_coor[0]]]["tipo"] == "mensaje":
                    #Mostrando mensaje
                    mensaje = mapas[mapa_no][mapa_datos[nueva_coor[1]][nueva_coor[0]]]["valor"]
                elif mapas[mapa_no][mapa_datos[nueva_coor[1]][nueva_coor[0]]]["tipo"] == "tesoro":
                    #Recolectando tesoros
                    tesoros_colectados = int(tesoros_colectados)
                    tesoros_colectados += mapas[mapa_no][mapa_datos[nueva_coor[1]][nueva_coor[0]]]["valor"]
                    tesoros_colectados = str(tesoros_colectados)
                    mapas[mapa_no][mapa_datos[nueva_coor[1]][nueva_coor[0]]]["valor"] = 0

                posicion_mago_x, posicion_mago_y = coor_a_pos(nueva_coor)
                coor_mago = nueva_coor
            else:
                print("no existe")

        else:
            #El valor de la coordenadas es un número, si es cero entonces no moverse
            if int(mapa_datos[nueva_coor[1]][nueva_coor[0]]) == -1:
                if direcc == "derecha":
                    nueva_coor[0] -= 1
                if direcc == "izquierda":
                    nueva_coor[0] += 1
                if direcc == "arriba":
                    nueva_coor[1] += 1
                if direcc == "abajo":
                    nueva_coor[1] -= 1
            else:
                posicion_mago_x, posicion_mago_y = coor_a_pos(nueva_coor)
                coor_mago = nueva_coor
    jump start

label combate:
    python:
        mensaje = "Has atacado" + str(enemigo_coor)
        mapa_enemigos[enemigo_coor[0]][enemigo_coor[1]] = None
        if mapa_enemigos[enemigo_coor[0]][enemigo_coor[1]] == None:
            mensaje = ""
            enemigo = ""
            enemigo_coor = []
            renpy.transition(dissolve)
            renpy.call_screen("mostrar_mapa")
        else:
            renpy.call_screen("mapa_combate")

screen fin_combate:
    text "El combate ha terminado.":
        at transform:
            pos [0.5, 0.5] alpha 0.0
            linear 0.5 alpha 1.0
    key "K_SPACE" action Jump("start")

screen mapa_combate:
    add mapas[0]["nombre"] + ".png":
        pos [0, 0]
    add "mago.png":
        pos coor_a_pos([5,5])

    add enemigo + ".png":
        pos coor_a_pos([15,5])

    frame:
        background Solid((55,55,55, 230))
        xpos 0.1
        ypos 0.6
        xsize 350
        textbutton "[1] Atacar":
            keysym "1"
            action Call("combate")
            padding 50, 50, 50, 50
        textbutton "[2] Magia":
            keysym "2"
            action Call("combate")
            padding 50, 100, 50, 50
        textbutton "[3] Huir":
            keysym "3"
            action Jump("start")
            padding 50, 150, 50, 50

    text mensaje:
        at transform:
            pos [0.5, 0.5] alpha 0.0
            linear 0.5 alpha 1.0
    $ mensaje = ""
